import "Turbine";
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Turbine.Gameplay";

-- Globlis vltozk
debugMode = false;
pluginName = "Gear Up";
pluginRoot = "/Bunny/GearUp/";
shellCommandName = "gearup";
pluginFullIdText = "Gear Up";

import "Bunny.GearUp.Class";
import "Bunny.GearUp.Type";
import "Bunny.GearUp.VindarPatch";

import "Bunny.GearUp.BaseFunc";
import "Bunny.GearUp.BaseClass";
import "Bunny.GearUp.ClassTPluginData";
import "Bunny.GearUp.ClassTOptions";
import "Bunny.GearUp.ClassTDesktopIcon";

localPlayer=Turbine.Gameplay.LocalPlayer:GetInstance();
playerEquipment = localPlayer:GetEquipment();

optionsO = TOptions();
optionsO:LoadData();
pluginDataO = TPluginData();
pluginDataO:LoadState();
desktopIkonO = TDesktopIcon();
wearedItemA = {};
slotItemA = {};
multiItemA = {};

-- Minden moty ltrehozsa
-- ===================================
function CreatePlugin()
	debug("@Main:CreatePlugin()");
	
	mainWindow = Turbine.UI.Lotro.Window();
	mainWindow:SetMinimumSize(300, 180);
	mainWindow:SetSize(300, 180);
	mainWindow:SetText("Gear Up!");
	mainWindow.PositionChanged = function(sender, args)
		optionsO.mainLeft = sender:GetLeft();
		optionsO.mainTop = sender:GetTop();
	end
	gearMenu = Turbine.UI.ContextMenu();
	gearMenuItems = gearMenu:GetItems();

	labelMWGearName = TLabel(mainWindow, "Selected gear:", 20, 35, 100, 20);
	editWMGearName = TEdit(mainWindow, 115, 35, 140, 20);
	editWMGearName:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	editWMGearName:SetReadOnly(true);
	btnMainCancel = TButton(mainWindow, 'Close', (mainWindow:GetWidth()/2)-50, 147, 100, 20);	
	btnMainCancel.Click = function() mainWindow:SetVisible(false); end	
	selectGearBtn = TImageButton(mainWindow, 255,35,20,20, pluginRoot .. "resource/gearselectbtn.tga", pluginRoot .. "resource/gearselectbtn.tga", pluginRoot .. "resource/gearselectbtn.tga");
	selectGearBtn.MouseClick = function() gearMenu:ShowMenu() 	end
	
	optionsButton = TImageButton(mainWindow,mainWindow:GetWidth()-50,145,25,25, pluginRoot .. "resource/options.tga", pluginRoot .. "resource/options_pressed.tga", pluginRoot .. "resource/options_rollover.tga");
	optionsButton.Click = function() 
		Turbine.PluginManager.ShowOptions(Plugins[pluginName]);
	end
	
	labelAllItemOK = TLabel(mainWindow, "All item is equipped!", 0, 80, 300, 30);
	labelAllItemOK:SetFont(Turbine.UI.Lotro.Font.TrajanPro28);
	labelAllItemOK:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
	labelAllItemOK:SetForeColor(Turbine.UI.Color(0,1,0));
	labelAllItemOK:SetVisible(false);
	
	playerEquipment.ItemEquipped = function(sender, args)
		debug("equip item: ".. args.Item:GetName());
		RepaintMainWindow(nil, args.Item:GetName());
	end
	playerEquipment.ItemUnequipped = function(sender, args)
		debug("unequip item:" .. args.Item:GetName());
		RepaintMainWindow(args.Index, nil);
	end
	wearedItemA = {};
	slotItemA = {};
	ikondb = 0;
	for index, value in pairs(SlotOrder) do
		newLeft = 20+(ikondb*41);
		ikondb = ikondb + 1;
		wearedItemA[ikondb] = TWearSlot(mainWindow, newLeft, 60, value);
		slotItemA[ikondb] = TItemSlot(mainWindow, newLeft, 101, value, nil, true);		
	end
	GearMenuRefresh();
end	-- CreatePlugin

-- Gear vlaszt men
-- ===================================
function GearMenuRefresh()
	debug("@Main GearMenuRefresh()");
	gearMenuItems:Clear();
	for k, v in pairs( pluginDataO.gearSets ) do
		gearMenuItems:Add(Turbine.UI.MenuItem(k));
	end
	for i=1, gearMenuItems:GetCount() do
		gearMenuItems:Get(i).Click = function(sender, args) 
			if sender:GetText() == "- clear -" then
				editWMGearName:SetText("");
			else
				editWMGearName:SetText(sender:GetText());
				if pluginDataO.gearSets[editWMGearName:GetText()] ~= nil then
					optionsO.activeItemSetName = editWMGearName:GetText();
					RepaintMainWindow();
				end
				
			end
			gearMenu:Close(); 
		end;
	end	
end -- GearMenuRefresh

-- Adott nev itembl hny db van a bagban
-- ===================================
function InTheBag(itemName)
-- Elg bugos, kszi turbine :/
	--debug("@Main InTheBag(" ..itemName..")");
	if optionsO.yellowMode == false then return 0; end	-- ha nincs yellow mode nem kell szmolni	
	local hatizsak = localPlayer:GetBackpack();
	local cuccDb = hatizsak:GetSize();
	local talalat = 0;
	for f=1, cuccDb do 
		if hatizsak:GetItem(f) ~= nil then
			if hatizsak:GetItem(f):GetName() == itemName then talalat = talalat + 1; end;
		end
	end
--	if talalat>0 then debug("InTheBag " .. talalat .. "pc " .. itemName); end;	
	return talalat;
end	-- InTheBag


-- Fablak frisstse
-- ===================================
function RepaintMainWindow(unequipIndex, equipItemName)
	if unequipIndex == nil then unequipIndex = -1; end;
	if equipItemName == nil then equipItemName = "0000"; end;
	debug("@Main RepaintMainWindow("..unequipIndex.." , "..equipItemName..")");
	if pluginDataO.gearSets[optionsO.activeItemSetName] == nil then
		debug("Ervenytelen set nev:" .. optionsO.activeItemSetName);
		optionsO.activeItemSetName = "";
	end
	local activeItemSetName = optionsO.activeItemSetName;
	
	mainWindow:SetPosition(optionsO.mainLeft,optionsO.mainTop);
	editWMGearName:SetText(activeItemSetName);

	-- Slotok felfrisstse
	iconPos = 0;
	visibleIcon = 0;
	needAlert = 0;
	labelAllItemOK:SetVisible(false);
	for index, value in pairs(SlotOrder) do	-- value = slotID
		iconPos = iconPos + 1;
		showIcon = false;
		wearedItemA[iconPos]:SetVisible(false);
		slotItemA[iconPos]:SetVisible(false);
		slotItemA[iconPos].ISlot:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Item));	
		wiName = wearedItemA[iconPos]:GetName();
		siName = "";
		if pluginDataO.gearSets[activeItemSetName] ~= nil then
			if pluginDataO.gearSets[activeItemSetName][value] ~= nil then
				slotItemA[iconPos]:SetItem(pluginDataO.gearSets[activeItemSetName][value]["id"]);
				siName = slotItemA[iconPos]:GetName();				
				if wiName == siName then	-- Ha ez van rajta
					itemInBag = InTheBag(siName);
					if itemInBag == 0 then	-- Ha nincs tbb ilyen a zskban
						slotItemA[iconPos]:SetStatus("ok");						
					else					-- Tallt mg ilyent a zskban
						if equipItemName == wiName then	-- Ezt a cuccot veszi pp fel
							if itemInBag == 1 then		-- Furcsa md mr felvette de zskban is ott van!
								slotItemA[iconPos]:SetStatus("ok");						
							else						-- Legalbb 2 azonos nev a zskban
								slotItemA[iconPos]:SetStatus("multi");						
								needAlert = 2;
								debug("Multi: " .. wiName .. " - " .. siName);
								showIcon = true;								
							end
						else	-- Nem ezt veszi fel s van belle a zskban is meg rajta is
							slotItemA[iconPos]:SetStatus("multi");						
							needAlert = 2;
							debug("Multi: " .. wiName .. " - " .. siName);
							showIcon = true;							
						end
					end
				else					
					slotItemA[iconPos]:SetStatus("wrong");
					needAlert = 1;
					showIcon = true;
					debug(wiName .. " - " .. siName);
				end
				if unequipIndex == value then
					slotItemA[iconPos]:SetStatus("wrong");					
					needAlert = 1;
				end
			end			
		end		
		if (wiName ~= siName) and (siName ~= "")  then
			showIcon = true;
		end
		if (unequipIndex == value) and (siName ~= "") then
			showIcon = true;
		end
		desktopIkonO.alert_status = needAlert;
		desktopIkonO:Repaint();
			
		if showIcon then
			newLeft = 20+(visibleIcon*41);		
			wearedItemA[iconPos]:SetVisible(true);
			wearedItemA[iconPos]:SetLeft(newLeft);
			slotItemA[iconPos]:SetVisible(true);
			slotItemA[iconPos]:SetLeft(newLeft);
			visibleIcon = visibleIcon + 1;
		end
	end
	-- slot frissts vge
	
	mainWindow:SetWidth((visibleIcon*41)+50);
	optionsButton:SetLeft(mainWindow:GetWidth()-50);
	btnMainCancel:SetLeft((mainWindow:GetWidth()/2)-50);
	if (visibleIcon == 0) then
		labelAllItemOK:SetVisible(true);
	end
	pluginDataO.visibleIcon = visibleIcon;
end

-- *************************************************
-- Plugin betltse
-- *************************************************
Plugins[pluginName].Load = function(self, sender, args)
	debug("@@Plugin load");
	pluginFullIdText = self:GetName() .. " v" .. self:GetVersion() .. " (c) 2015 " .. self:GetAuthor();
	Turbine.Shell.WriteLine("Plugin " .. pluginFullIdText);
	if debugMode then Turbine.Shell.WriteLine("Debug mode ON") end
	
	optionsO:CreateOptionWindow();
	CreatePlugin();
	pluginDataO:CreateGearSetupWindow();
	RepaintMainWindow();
	
	if optionsO.showIfLoad then
		mainWindow:SetVisible(true);
		mainWindow:Activate();
	else
		mainWindow:SetVisible(false);		
	end;
	
	if Turbine.Shell.IsCommand(shellCommandName) then
		debug("A ".. shellCommandName .. " parancs mr regisztlt!");
	else
		myCommandLine = Turbine.ShellCommand();
		-- Parancsok feldolgozsa
		function myCommandLine:Execute( name, shellCommand )
			shellCommand = string.lower(shellCommand);
			if (shellCommand == "setup") or (shellCommand == "options") then
				Turbine.PluginManager.ShowOptions(Plugins[pluginName]);
			elseif (shellCommand == "show") or (shellCommand == "on") then
				mainWindow:SetVisible(true);
				mainWindow:Activate();
			elseif (shellCommand == "hide") or (shellCommand == "off") then
				mainWindow:Close();
			else 
				myCommandLine:GetHelp();
			end
		end
		-- Rvid help
		function myCommandLine:GetShortHelp()
			echo("Command: <rgb=#FFFFFF>/"..shellCommandName.."</rgb> [show|on] [hide|off] [setup|options] [help]");
		end
		-- Rszletes help
		function myCommandLine:GetHelp()
			echo(string.rep("=",string.len(pluginFullIdText)));
			echo(pluginFullIdText);
			echo(string.rep("=",string.len(pluginFullIdText)));
			echo("USAGE: /"..shellCommandName.." [command]\n");
			echo("COMMANDS:");
			echo("help - show this help (also if no command)");
			echo("show|on - show the plugin");
			echo("hide|off - hide the plugin");
			echo("setup|options - show the options window");
			echo("");
		end
		
		Turbine.Shell.AddCommand( shellCommandName, myCommandLine );
		Plugins[pluginName].GetOptionsPanel = function(self) return pluginManagerForm end;
		echo(myCommandLine:GetShortHelp());
	end
end

-- *************************************************
-- Plugin megszntetse
-- *************************************************
Plugins[pluginName].Unload = function(self,sender,args)
	debug("@@Plugin unload");
--	RemoveCallback(playerEquipment, "ItemEquipped");
--	RemoveCallback(playerEquipment, "ItemUnequipped");
	
	if Turbine.Shell.IsCommand(shellCommandName) then
		Turbine.Shell.RemoveCommand(shellCommandName);
	end	
	optionsO:SaveState();
	Plugins[pluginName].GetOptionsPanel = nil;
	
	debug(pluginFullIdText .. " has removed!");	
end;

